diff --git a/lib/hive/commands/init/prompts.rb b/lib/hive/commands/init/prompts.rb
index 088635f9c..bf7327eb7 100644
--- a/lib/hive/commands/init/prompts.rb
+++ b/lib/hive/commands/init/prompts.rb
@@ -109,6 +109,7 @@ module Hive
           triage_bias = prompt_triage_bias
           budgets, timeouts = prompt_limits
           daemon_enabled = prompt_daemon_enabled
+          daemon_service_enable_start = prompt_daemon_service
 
           answers = {
             "planning_agent" => planning,
@@ -117,7 +118,8 @@ module Hive
             "triage_bias" => triage_bias,
             "budgets" => budgets,
             "timeouts" => timeouts,
-            "daemon_enabled" => daemon_enabled
+            "daemon_enabled" => daemon_enabled,
+            "daemon_service_enable_start" => daemon_service_enable_start
           }
 
           summarize(answers)
@@ -143,7 +145,8 @@ module Hive
             "triage_bias" => DEFAULT_TRIAGE_BIAS,
             "budgets" => default_budgets,
             "timeouts" => default_timeouts,
-            "daemon_enabled" => true
+            "daemon_enabled" => true,
+            "daemon_service_enable_start" => false
           }
           # Goes to @summary_io (stdout by default) so a non-TTY caller's
           # `summary=$(hive init)` capture has a parseable single line.
@@ -352,6 +355,28 @@ module Hive
           end
         end
 
+        # Whether to enable + start the OS-registered daemon service now.
+        # Defaults to NO side effect: non-interactive sessions and blank/`n`
+        # answers both return false, so autostart is never silent. The caller
+        # (Init#register_daemon_service) registers the unit file unconditionally
+        # after a successful init; declining here leaves it registered but not
+        # enabled/started.
+        def prompt_daemon_service
+          return false unless interactive?
+
+          @output.puts ""
+          @output.puts "Register hive daemon as a background service (launchd / systemd --user)?"
+          loop do
+            @output.print "Enable and start the daemon service now? [y/N]: "
+            @output.flush
+            answer = read_line.downcase
+            return true  if answer == "y" || answer == "yes"
+            return false if answer.empty? || answer == "n" || answer == "no"
+
+            @output.puts "  please answer y or n"
+          end
+        end
+
         def summarize(answers)
           @output.puts ""
           @output.puts "Summary:"
diff --git a/lib/hive/commands/prune.rb b/lib/hive/commands/prune.rb
index c91f02d7b..8b1f2a06e 100644
--- a/lib/hive/commands/prune.rb
+++ b/lib/hive/commands/prune.rb
@@ -4,7 +4,7 @@ require "hive/config"
 module Hive
   module Commands
     # `hive prune [--dry-run] [--json]` — drop every registry entry in
-    # ~/Dev/hive/config.yml whose `path` no longer points at a directory.
+    # ~/.config/hive/config.yml whose `path` no longer points at a directory.
     # Also drops malformed entries (non-Hash rows, rows missing `path`,
     # rows whose `path` isn't a String) — these are hand-edit accidents
     # and have always been undisplayable in `hive status`. The
diff --git a/lib/hive/commands/uninstall.rb b/lib/hive/commands/uninstall.rb
new file mode 100644
index 000000000..985b84e38
--- /dev/null
+++ b/lib/hive/commands/uninstall.rb
@@ -0,0 +1,190 @@
+# frozen_string_literal: true
+
+require "fileutils"
+require "hive/config"
+require "hive/install"
+require "hive/service"
+
+module Hive
+  module Commands
+    # `hive uninstall` — remove hive cleanly (plan: install/packaging U3).
+    #
+    # Removes, in order: the daemon service registration, the installed
+    # binary (per install channel), the global config + install-channel
+    # record, and each registered project's `.hive-state/` directory.
+    #
+    # Safety contracts (R-UNINST):
+    #   * Completed work is preserved — `.hive-state/stages/8-done/` is left
+    #     in place when a project's state is removed.
+    #   * Interactive mode prompts before deleting anything and per-project
+    #     before touching each `.hive-state/`.
+    #   * `--purge` is the non-interactive CI path: no prompts, but it still
+    #     preserves completed pipeline outputs.
+    #
+    # The shell-out command runner is injectable for tests.
+    class Uninstall
+      def initialize(json: false, purge: false, runner: nil,
+                     channel: Hive::Install.install_channel,
+                     input: $stdin, output: $stdout)
+        @json = json
+        @purge = purge
+        @runner = runner
+        @channel = channel
+        @input = input
+        @output = output
+      end
+
+      def call
+        unless @purge
+          confirm_global
+        end
+
+        # Snapshot registered projects BEFORE removing the global config, or
+        # the registry read below would return [] and skip project cleanup.
+        projects = Hive::Config.registered_projects
+
+        removed_service = Hive::Service.remove!
+        remove_binary!
+        remove_global_config!
+
+        removed_projects = projects.each_with_object([]) do |project, acc|
+          acc << project["name"] if remove_project_state!(project)
+        end
+
+        report(removed_service: removed_service, removed_projects: removed_projects)
+      end
+
+      # Remove the installed binary per channel. For bash installs this deletes
+      # the binary we own under bin_dir (and its `hv`/`hive` sibling when the
+      # command was installed under the conflict-fallback name). For brew/aur
+      # the package manager owns the binary, so we shell out to its uninstaller.
+      def remove_binary!
+        case @channel
+        when "bash"
+          File.delete(Hive::Install.binary_path) if File.exist?(Hive::Install.binary_path)
+        when "brew"
+          run(%w[brew uninstall hive])
+        when "aur"
+          run(%w[yay -R hive-bin])
+        else
+          # Unknown/unrecorded channel — the binary isn't ours to manage.
+          @output.puts "hive: no install channel recorded; skipping binary removal" if @output
+        end
+      rescue Errno::ENOENT, Errno::EACCES
+        # binary already gone or not removable — nothing to do
+      end
+
+      def remove_global_config!
+        File.delete(Hive::Config.global_config_path) if File.exist?(Hive::Config.global_config_path)
+        Hive::Install.clear_install_channel!
+        Hive::Install.clear_command_name!
+
+        # Removing config.yml / install-channel / command-name can leave the
+        # XDG dirs empty; clean them up so uninstall doesn't strand empty
+        # shells. Only EMPTY dirs are removed — a live daemon's pid/log files
+        # (under state/) keep that tree populated and are left alone.
+        [ Hive::Paths.config_dir, Hive::Paths.state_dir, Hive::Paths.cache_dir ].each do |dir|
+          remove_dir_if_empty(dir)
+        end
+      end
+
+      def remove_dir_if_empty(dir)
+        return unless dir && File.directory?(dir)
+
+        Dir.rmdir(dir) if Dir.empty?(dir)
+      rescue SystemCallError
+        nil
+      end
+
+      # Remove one project's `.hive-state/` preserving completed work under
+      # `stages/8-done/`. Returns true when state was removed. Interactive mode
+      # prompts per project; `--purge` removes without prompting.
+      def remove_project_state!(project)
+        hive_state = project["hive_state_path"]
+        return false unless hive_state && File.directory?(hive_state)
+
+        unless @purge
+          return false unless confirm_project(project)
+        end
+
+        preserve_completed_work(hive_state)
+        true
+      end
+
+      # Delete everything under a project's .hive-state EXCEPT stages/8-done
+      # (completed, merged work is never destroyed by uninstall).
+      def preserve_completed_work(hive_state)
+        stages = File.join(hive_state, "stages")
+        done = File.join(stages, "8-done")
+
+        # Remove every top-level child of .hive-state except the `stages/`
+        # tree (which we handle selectively below).
+        Dir.children(hive_state).each do |child|
+          next if child == "stages"
+
+          FileUtils.rm_rf(File.join(hive_state, child))
+        end
+
+        return unless File.directory?(stages)
+
+        Dir.children(stages).each do |child|
+          next if child == "8-done"
+
+          FileUtils.rm_rf(File.join(stages, child))
+        end
+
+        # Leave 8-done in place even when empty — it is the completed-work marker.
+        _ = done
+      end
+
+      def confirm_global
+        return unless interactive?
+
+        @output.print "Uninstall hive (binary, daemon service, global config, and per-project .hive-state)? [y/N]: "
+        @output.flush
+        answer = @input.gets
+        return if answer && answer.strip =~ /\Ay(?:es)?\z/i
+
+        raise Hive::Error, "uninstall aborted"
+      end
+
+      def confirm_project(project)
+        return true unless interactive?
+
+        @output.print "Remove #{project['name']} .hive-state (preserves completed work)? [y/N]: "
+        @output.flush
+        answer = @input.gets
+        answer && answer.strip =~ /\Ay(?:es)?\z/i
+      end
+
+      def interactive?
+        @input.respond_to?(:tty?) && @input.tty?
+      end
+
+      def run(cmd)
+        if @runner
+          @runner.call(cmd)
+        else
+          system(*cmd)
+        end
+      end
+
+      def report(removed_service:, removed_projects:)
+        if @json
+          require "json"
+          puts JSON.generate(
+            "schema" => "hive-uninstall",
+            "schema_version" => 1,
+            "ok" => true,
+            "removed_service" => removed_service,
+            "removed_projects" => removed_projects,
+            "channel" => @channel
+          )
+        else
+          puts "hive: uninstalled#{removed_service ? ' (daemon service removed)' : ''}" \
+               "#{removed_projects.empty? ? '' : " (removed #{removed_projects.size} project state dir(s))"}"
+        end
+      end
+    end
+  end
+end
diff --git a/lib/hive/commands/update.rb b/lib/hive/commands/update.rb
new file mode 100644
index 000000000..85563d3b2
--- /dev/null
+++ b/lib/hive/commands/update.rb
@@ -0,0 +1,80 @@
+# frozen_string_literal: true
+
+require "open3"
+require "hive/install"
+
+module Hive
+  module Commands
+    # `hive update` — update the hive binary via its native package manager
+    # (plan: install/packaging U3). Never rewrites the binary in place
+    # (R-UPD): it detects the recorded install channel and shells out to the
+    # updater that owns it.
+    #
+    #   brew  → `brew upgrade hive`
+    #   aur   → `yay -Syu hive-bin`
+    #   bash  → re-runs the install.sh one-liner
+    #
+    # The command runner is injectable for tests (assert command assembly
+    # without network); production shells out for real.
+    class Update
+      def initialize(json: false, runner: nil, channel: Hive::Install.install_channel)
+        @json = json
+        @runner = runner
+        @channel = channel
+      end
+
+      def call
+        unless Hive::Install::CHANNELS.include?(@channel)
+          raise Hive::Error, channel_error_message
+        end
+
+        cmd = update_command(@channel)
+        raise Hive::Error, "update failed (channel #{@channel})" unless run_update_command(cmd)
+
+        report_success
+      end
+
+      def run_update_command(cmd)
+        return @runner.call(cmd) if @runner
+        return system(*cmd) if cmd.is_a?(Array)
+
+        system(cmd)
+      end
+
+      # The shell command each channel maps to. Public for unit tests so they
+      # can assert the exact argv without invoking it.
+      def update_command(channel)
+        case channel
+        when "brew" then %w[brew upgrade hive]
+        when "aur"  then %w[yay -Syu hive-bin]
+        when "bash" then "curl -fsSL #{Hive::Install::INSTALL_SH_URL} | bash"
+        end
+      end
+
+      def report_success
+        if @json
+          require "json"
+          puts JSON.generate(
+            "schema" => "hive-update",
+            "schema_version" => 1,
+            "ok" => true,
+            "channel" => @channel,
+            "command" => update_command(@channel)
+          )
+        else
+          puts "hive: update requested via #{@channel}"
+        end
+      end
+
+      def channel_error_message
+        known = Hive::Install::CHANNELS.join(", ")
+        if @channel.nil? || @channel.to_s.strip.empty?
+          "hive: install channel unknown (no install-channel record); " \
+          "reinstall via a supported package manager or install.sh"
+        else
+          "hive: unknown install channel #{@channel.inspect} (known: #{known})"
+        end
+      end
+    end
+  end
+end
diff --git a/lib/hive/config.rb b/lib/hive/config.rb
index a67097d8d..6f1764db3 100644
--- a/lib/hive/config.rb
+++ b/lib/hive/config.rb
@@ -1,5 +1,6 @@
 require "yaml"
 require "fileutils"
+require "hive/paths"
 require "hive/agent_profiles"
 
 module Hive
@@ -158,7 +159,7 @@ module Hive
       },
       # Global Telegram bot settings. The bot is an operator surface
       # across every registered project, so runtime code loads these
-      # from ~/Dev/hive/config.yml via load_global_bot. The token lives
+      # from ~/.config/hive/config.yml via load_global_bot. The token lives
       # only in HIVE_TELEGRAM_BOT_TOKEN and is never persisted.
       "bot" => {
         "enabled" => false,
@@ -170,11 +171,11 @@ module Hive
         "codex_budget_usd" => 1,
         "codex_timeout_sec" => 120,
         "shutdown_grace_sec" => 60,
-        "pid_file" => "~/Dev/hive/.bot.pid",
-        "log_file" => "~/Dev/hive/logs/bot.log",
+        "pid_file" => "~/.local/state/hive/.bot.pid",
+        "log_file" => "~/.local/state/hive/logs/bot.log",
         "log_max_bytes" => 10_485_760,
         "log_max_files" => 5,
-        "last_seen_state_file" => "~/Dev/hive/.bot.last_seen_update_id"
+        "last_seen_state_file" => "~/.local/state/hive/.bot.last_seen_update_id"
       },
       # Auto-rebase pre-step for `hive run` (plan
       # docs/plans/2026-05-14-001-feat-hive-auto-rebase-stale-worktree-plan.md).
@@ -209,7 +210,7 @@ module Hive
     module_function
 
     def hive_home
-      ENV["HIVE_HOME"] || File.expand_path("~/Dev/hive")
+      Hive::Paths.config_dir
     end
 
     def global_config_path
@@ -253,8 +254,40 @@ module Hive
       raise ConfigError, "HIVE_HOME is set to a path that does not exist: #{env}"
     end
 
+    # One-way migration from the pre-XDG global home (`~/.config/hive/config.yml`)
+    # to the XDG config dir (plan: install/packaging U2). On first run after
+    # an upgrade, if the legacy config exists and no XDG config does, copy it
+    # over so the registered-projects registry and bot/daemon state survive.
+    # The original file is never deleted — the migration is additive and
+    # log-only, so a user can always roll back by re-pointing HIVE_HOME at
+    # the old checkout.
+    #
+    # Skipped when HIVE_HOME is explicitly set (the operator has told us
+    # where to look; do not second-guess them) and guarded by a module-level
+    # flag so repeated read/write paths in one process only attempt it once.
+    def migrate_legacy_home!
+      return if @__legacy_migration_attempted
+      @__legacy_migration_attempted = true
+
+      env = ENV["HIVE_HOME"]
+      return if env && !env.empty?
+
+      legacy = Hive::Paths.legacy_config_path
+      return unless File.exist?(legacy)
+
+      target = global_config_path
+      return if File.exist?(target)
+
+      FileUtils.mkdir_p(File.dirname(target))
+      FileUtils.cp(legacy, target)
+      warn "hive: migrated global config from #{legacy} to #{target} (original left in place)"
+    rescue StandardError => e
+      warn "hive: could not migrate legacy config #{legacy}: #{e.class}: #{e.message}"
+    end
+
     def registered_projects
       validate_hive_home!
+      migrate_legacy_home!
       path = global_config_path
       return [] unless File.exist?(path)
 
@@ -299,7 +332,7 @@ module Hive
     # same `error_kind: "config"` envelope the TUI's narrow rescue catches.
     #
     # EACCES specifically is the most user-facing of the IO group:
-    # `chmod 000 ~/Dev/hive/config.yml` (or running as a different
+    # `chmod 000 ~/.config/hive/config.yml` (or running as a different
     # user) used to surface as `internal error: Errno::EACCES: ...`
     # at exit 70. The root cause is configuration access, not a Hive
     # bug — exit 78 is the right shape.
@@ -311,7 +344,7 @@ module Hive
       raise ConfigError, "global config at #{path} is not readable: #{e.message}"
     end
 
-    # Atomic + EACCES-aware writer for ~/Dev/hive/config.yml. Mirrors
+    # Atomic + EACCES-aware writer for ~/.config/hive/config.yml. Mirrors
     # the shape of `Hive::Markers.write_atomic` so a future flock
     # upgrade (Issue #31) can swap in here without rewriting every
     # call site. Permission errors on write surface as ConfigError
@@ -327,7 +360,7 @@ module Hive
     end
 
     # Load and validate the global `daemon` block from
-    # `~/Dev/hive/config.yml`. Returns the merged Hash (operator
+    # `~/.config/hive/config.yml`. Returns the merged Hash (operator
     # overrides on top of `Config::DEFAULTS["daemon"]`). Used by
     # `hive daemon start` / `reload` so operator knobs in the global
     # config (max_concurrent_runs, poll_interval_sec, log_*, etc.)
@@ -337,6 +370,7 @@ module Hive
     # present (first-run scenario, no projects registered yet).
     def load_global_daemon
       validate_hive_home!
+      migrate_legacy_home!
       path = global_config_path
       data = File.exist?(path) ? load_global_config(path) : {}
       raise ConfigError, "global config at #{path} must be a hash" unless data.is_a?(Hash)
@@ -355,12 +389,13 @@ module Hive
       merged
     end
 
-    # Load and validate the global `bot` block from ~/Dev/hive/config.yml.
+    # Load and validate the global `bot` block from ~/.config/hive/config.yml.
     # `require_runtime: true` is used by `hive bot start` so the opt-in
     # credentials fail loudly there without making read-only commands like
     # `hive status` require a Telegram token.
     def load_global_bot(require_runtime: false)
       validate_hive_home!
+      migrate_legacy_home!
       path = global_config_path
       data = File.exist?(path) ? load_global_config(path) : {}
       raise ConfigError, "global config at #{path} must be a hash" unless data.is_a?(Hash)
@@ -386,13 +421,14 @@ module Hive
 
     def global_bot_defaults
       defaults = deep_dup(DEFAULTS["bot"])
-      defaults["pid_file"] = File.join(hive_home, ".bot.pid")
-      defaults["log_file"] = File.join(hive_home, "logs", "bot.log")
-      defaults["last_seen_state_file"] = File.join(hive_home, ".bot.last_seen_update_id")
+      defaults["pid_file"] = File.join(Hive::Paths.state_dir, ".bot.pid")
+      defaults["log_file"] = File.join(Hive::Paths.state_dir, "logs", "bot.log")
+      defaults["last_seen_state_file"] = File.join(Hive::Paths.state_dir, ".bot.last_seen_update_id")
       defaults
     end
 
     def register_project(name:, path:)
+      migrate_legacy_home!
       FileUtils.mkdir_p(hive_home)
       data = if File.exist?(global_config_path)
                load_global_config(global_config_path)
diff --git a/lib/hive/daemon/child_supervisor.rb b/lib/hive/daemon/child_supervisor.rb
index fd87d15ab..083bbd77b 100644
--- a/lib/hive/daemon/child_supervisor.rb
+++ b/lib/hive/daemon/child_supervisor.rb
@@ -73,7 +73,7 @@ module Hive
         FileUtils.mkdir_p(File.dirname(log_path))
         # Open with truncation ("w") so each child run starts a fresh
         # per-task log; logs from prior runs are not preserved here —
-        # the daemon's own log file at ~/Dev/hive/logs/daemon.log
+        # the daemon's own log file at ~/.local/state/hive/logs/daemon.log
         # carries the cross-run history.
         log_io = File.open(log_path, "w")
         log_io.puts("[hive-daemon] #{Time.now.utc.iso8601} spawn argv=#{argv.inspect}")
diff --git a/lib/hive/daemon/dispatcher.rb b/lib/hive/daemon/dispatcher.rb
index 4f6d34509..4d38516f2 100644
--- a/lib/hive/daemon/dispatcher.rb
+++ b/lib/hive/daemon/dispatcher.rb
@@ -513,7 +513,7 @@ module Hive
       end
 
       def reload_config!
-        # PR-40 review P1 #2: rebase on the global ~/Dev/hive/config.yml's
+        # PR-40 review P1 #2: rebase on the global ~/.config/hive/config.yml's
         # daemon block, not bare DEFAULTS.
         @daemon_cfg = Hive::Config.load_global_daemon
         @config = { "daemon" => @daemon_cfg }
diff --git a/lib/hive/dependencies.rb b/lib/hive/dependencies.rb
new file mode 100644
index 000000000..ee6a8c850
--- /dev/null
+++ b/lib/hive/dependencies.rb
@@ -0,0 +1,171 @@
+# frozen_string_literal: true
+
+require "open3"
+require "timeout"
+
+require "hive"
+
+module Hive
+  # Runtime dependency detection (plan: install/packaging U5).
+  #
+  # Enumerates the external tools the hive CLI relies on (`git`, `bash`,
+  # `claude`, `gh`, `jq`) with minimum versions and per-OS install hints, so
+  # `hive doctor` can report a missing tool with an actionable command instead
+  # of failing a stage mid-run. No silent auto-install: this module only
+  # reports; the operator (or installer) decides whether to install.
+  #
+  # `claude`'s minimum version is Hive::MIN_CLAUDE_VERSION (2.1.118), the same
+  # gate AgentProfile#check_version! enforces at spawn time. The rest are
+  # presence + a conservative floor chosen so version-flag parsing is uniform.
+  module Dependencies
+    VERSION_CHECK_TIMEOUT_SEC = 5
+
+    TOOLS = [
+      {
+        "name" => "git",
+        "min_version" => "2.40.0",
+        "flag" => "--version",
+        "hints" => {
+          "macos" => "brew install git",
+          "ubuntu" => "sudo apt install git",
+          "arch" => "sudo pacman -S git",
+          "default" => "install git (see https://git-scm.com/downloads)"
+        }
+      },
+      {
+        "name" => "bash",
+        "min_version" => "3.2.0",
+        "flag" => "--version",
+        "hints" => {
+          "macos" => "brew install bash",
+          "ubuntu" => "sudo apt install bash",
+          "arch" => "sudo pacman -S bash",
+          "default" => "install bash"
+        }
+      },
+      {
+        "name" => "claude",
+        "min_version" => Hive::MIN_CLAUDE_VERSION,
+        "flag" => "--version",
+        "hints" => {
+          "macos" => "brew install claude-code  (or: npm install -g @anthropic-ai/claude-code)",
+          "ubuntu" => "npm install -g @anthropic-ai/claude-code",
+          "arch" => "npm install -g @anthropic-ai/claude-code",
+          "default" => "npm install -g @anthropic-ai/claude-code"
+        }
+      },
+      {
+        "name" => "gh",
+        "min_version" => "2.0.0",
+        "flag" => "--version",
+        "hints" => {
+          "macos" => "brew install gh",
+          "ubuntu" => "sudo apt install gh  (see https://cli.github.com for the apt repo)",
+          "arch" => "sudo pacman -S github-cli",
+          "default" => "install gh (see https://cli.github.com)"
+        }
+      },
+      {
+        "name" => "jq",
+        "min_version" => "1.6",
+        "flag" => "--version",
+        "hints" => {
+          "macos" => "brew install jq",
+          "ubuntu" => "sudo apt install jq",
+          "arch" => "sudo pacman -S jq",
+          "default" => "install jq (see https://jqlang.github.io/jq)"
+        }
+      }
+    ].freeze
+
+    module_function
+
+    # Rows for every required tool, shaped to drop into `hive doctor`'s table
+    # (`kind`, `label`, `agent`, `skill`, `status`, `message`, plus a `hint`
+    # carry field for the actionable install command).
+    def check
+      TOOLS.map { |tool| check_one(tool) }
+    end
+
+    def check_one(tool)
+      version = detect_version(tool["name"], tool["flag"])
+      label = "dependency/#{tool['name']}"
+      required = ">= #{tool['min_version']}"
+
+      if version.nil?
+        row(tool, label, "missing", nil, "not found on PATH", hint(tool))
+      elsif below_min?(version, tool["min_version"])
+        row(tool, label, "version_too_old", version, "found #{version}, needs #{required}", hint(tool))
+      else
+        row(tool, label, "present", version, "#{version} (#{required})", nil)
+      end
+    end
+
+    def row(tool, label, status, version, message, hint)
+      {
+        kind: "dependency",
+        label: label,
+        agent: tool["name"],
+        configured_skill: ">= #{tool['min_version']}",
+        skill: tool["name"],
+        status: status,
+        version: version,
+        message: message,
+        hint: hint
+      }
+    end
+
+    def hint(tool)
+      os = current_os
+      tool["hints"][os] || tool["hints"]["default"]
+    end
+
+    def current_os
+      host = RbConfig::CONFIG["host_os"]
+      return "macos" if host =~ /darwin/i
+      return "arch" if arch_linux?
+
+      "ubuntu"
+    end
+
+    # `host_os` is `linux`/`linux-gnu` on Arch (never `arch`), so the old
+    # `/arch/i` probe could never match. Detect Arch the way the distro
+    # actually identifies itself: `/etc/os-release` ID=arch (or a `pacman`
+    # binary on PATH for minimal/container images that strip os-release).
+    def arch_linux?
+      return true if File.exist?("/etc/os-release") &&
+                     File.read("/etc/os-release") =~ /^ID=["']?arch["']?\s*$/i
+
+      ENV["PATH"].to_s.split(File::PATH_SEPARATOR).any? do |dir|
+        File.executable?(File.join(dir, "pacman"))
+      end
+    end
+
+    # Run `<tool> --version` and parse the first x[.y[.z]] token. Returns nil
+    # when the binary is missing or its version cannot be parsed. Bounded by
+    # VERSION_CHECK_TIMEOUT_SEC so a wrapper binary that prompts/hangs cannot
+    # wedge `hive doctor`.
+    #
+    # Accepts 1–3 numeric components (not exactly three): `jq --version` on
+    # Ubuntu 22.04 prints `jq-1.6` — requiring `\d+\.\d+\.\d+` reported that
+    # tier-1 default as missing.
+    def detect_version(name, flag)
+      out, _err, status = Timeout.timeout(VERSION_CHECK_TIMEOUT_SEC) do
+        Open3.capture3(name, flag)
+      end
+      return nil unless status.success?
+
+      out[/\d+(?:\.\d+){0,2}/]
+    rescue Errno::ENOENT, Errno::EACCES, Timeout::Error
+      nil
+    end
+
+    def version_tuple(str)
+      str.split(".").map(&:to_i)
+    end
+
+    def below_min?(version, min_version)
+      (version_tuple(version) <=> version_tuple(min_version)).negative?
+    end
+  end
+end
diff --git a/lib/hive/install.rb b/lib/hive/install.rb
new file mode 100644
index 000000000..4413600ee
--- /dev/null
+++ b/lib/hive/install.rb
@@ -0,0 +1,108 @@
+# frozen_string_literal: true
+
+require "fileutils"
+require "hive/paths"
+
+module Hive
+  # Install-channel bookkeeping and command-name resolution (plan:
+  # install/packaging U3). At install time the installer records which
+  # distribution channel delivered the binary — `brew`, `aur`, or `bash`
+  # (the one-liner) — so `hive update` can shell out to the native updater
+  # and `hive uninstall` can clean up the right way.
+  module Install
+    CHANNELS = %w[brew aur bash].freeze
+
+    # Canonical install.sh location on GitHub Releases; the bash channel's
+    # updater re-runs it rather than swapping the binary in place.
+    INSTALL_SH_URL = "https://github.com/ivankuznetsov/hive/releases/latest/download/install.sh".freeze
+
+    module_function
+
+    def install_channel_path
+      File.join(Hive::Paths.config_dir, "install-channel")
+    end
+
+    # Where the installer records the command name (`hive` or the `hv`
+    # conflict-fallback) so `binary_path` resolves the binary that was
+    # actually installed, not the default.
+    def command_name_path
+      File.join(Hive::Paths.config_dir, "command-name")
+    end
+
+    # The recorded channel, or nil when unknown/unset (e.g. a dev clone).
+    def install_channel
+      path = install_channel_path
+      return nil unless File.exist?(path)
+
+      value = File.read(path).strip
+      value.empty? ? nil : value
+    rescue StandardError
+      nil
+    end
+
+    def record_install_channel!(channel)
+      FileUtils.mkdir_p(Hive::Paths.config_dir)
+      File.write(install_channel_path, "#{channel}\n")
+      channel
+    end
+
+    def clear_install_channel!
+      File.delete(install_channel_path) if File.exist?(install_channel_path)
+    rescue StandardError
+      nil
+    end
+
+    # The bin directory the installer drops the binary into. HIVE_BIN_DIR
+    # override wins (install.sh respects it too), else ~/.local/bin.
+    def bin_dir
+      override = ENV["HIVE_BIN_DIR"]
+      return override unless override.nil? || override.empty?
+
+      File.expand_path("~/.local/bin")
+    end
+
+    # The command name this install answers to: `hv` when a foreign `hive`
+    # owns the name (recorded by the installer), else `hive`. The explicit
+    # HIVE_COMMAND_NAME env override wins; otherwise the recorded value from
+    # the installer is authoritative, falling back to `hive`.
+    def command_name
+      name = ENV["HIVE_COMMAND_NAME"]
+      return name unless name.nil? || name.empty?
+
+      recorded = read_command_name
+      return recorded unless recorded.nil? || recorded.empty?
+
+      "hive"
+    end
+
+    def record_command_name!(name)
+      FileUtils.mkdir_p(Hive::Paths.config_dir)
+      File.write(command_name_path, "#{name}\n")
+      name
+    end
+
+    def read_command_name
+      path = command_name_path
+      return nil unless File.exist?(path)
+
+      value = File.read(path).strip
+      value.empty? ? nil : value
+    rescue StandardError
+      nil
+    end
+
+    def clear_command_name!
+      File.delete(command_name_path) if File.exist?(command_name_path)
+    rescue StandardError
+      nil
+    end
+
+    def hv_fallback?
+      command_name == "hv"
+    end
+
+    def binary_path
+      File.join(bin_dir, command_name)
+    end
+  end
+end
